//
//  Create Aliases.m
//  Create Aliases Automator action for Mac OS X
//
// Copyright (C) 2005 Ben Gertzfield
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without modification, 
// are permitted provided that the following conditions are met:
//
// Redistributions of source code must retain the above copyright notice, this list of
// conditions and the following disclaimer.
//
// Redistributions in binary form must reproduce the above copyright notice, this list 
// of conditions and the following disclaimer in the documentation and/or other materials 
// provided with the distribution.
//
// Ben Gertzfield's name may not be used to endorse or promote products derived from this
// software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
// OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY 
// AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
// DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
// IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
// OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

#import "AddMetadata.h"

#import <Foundation/NSFileManager.h>
#import <Automator/AMAction.h>
#import <OSAKit/OSAScript.h>
#import <Quartz/Quartz.h>

@implementation AddMetadata

- (id)runWithInput:(id)input fromAction:(AMAction *)anAction error:(NSDictionary **)errorInfo
{
		// Add your code here, returning the data to be passed to the next action.
		if (![input isKindOfClass:[NSArray class]])
	{
			input = [NSArray arrayWithObject:input];
	}
		
		
		NSString * myAuthor = [[self parameters] objectForKey:@"author"];
		NSLog (myAuthor);
		NSString * myTitle = [[self parameters] objectForKey:@"title"];
		NSLog(myTitle);
		
		NSString *path;
		NSEnumerator *enumerator = [input objectEnumerator];
		while (path = [enumerator nextObject])
	{
			NSLog(path);
			NSData * myData = [[[NSData alloc] initWithContentsOfFile:path] autorelease];
			PDFDocument * myPDF = [[[PDFDocument alloc] initWithData:myData] autorelease];
			
			NSMutableDictionary * myDict = [[[myPDF documentAttributes] mutableCopy] autorelease];
			[myDict setValue:myAuthor forKey:@"Author"/*PDFDocumentAuthorAttribute*/];
			[myDict setValue:myTitle forKey:@"Title"/*PDFDocumentTitleAttribute*/];
			
			[myPDF setDocumentAttributes:myDict];
			
			[myPDF writeToFile:path];
			//NSLog([myPDF description]);
			
	}
			return input;
	}
	/*
	
	NSMutableArray *returnArray = [NSMutableArray arrayWithCapacity:[input count]];
	NSEnumerator *enumerate = [input objectEnumerator];
	NSString *createAliasToThisFile;
	NSFileManager *manager = [NSFileManager defaultManager];
	
	NSString *createAliasInThisDirectory = [[self parameters] objectForKey:@"aliasFolder"];
	if (!createAliasInThisDirectory) {
		*errorInfo = [NSDictionary dictionaryWithObjectsAndKeys:
			[NSNumber numberWithInt:errOSASystemError], OSAScriptErrorNumber, 
			[NSString stringWithFormat:@"ERROR: Please specify a target directory\n"], OSAScriptErrorMessage, 
			nil];
		return nil;
	}
	
	while (createAliasToThisFile = [enumerate nextObject]) {
		int result;
		NSString *filename = [createAliasToThisFile lastPathComponent];
		NSString *newTargetLink = [createAliasInThisDirectory stringByAppendingPathComponent:filename];
		
		result = [manager createSymbolicLinkAtPath:newTargetLink pathContent:createAliasToThisFile];
		if (!result) {
			*errorInfo = [NSDictionary dictionaryWithObjectsAndKeys:
				[NSNumber numberWithInt:errOSASystemError], OSAScriptErrorNumber,
				[NSString stringWithFormat:@"ERROR: Could not make link from %@ to %@\n", createAliasToThisFile, newTargetLink],
 OSAScriptErrorMessage, 
				nil];
			return nil;
		}
		[returnArray addObject:newTargetLink];
	}
	
	return returnArray;
}
*/
@end
